/* Mixmaster version 3  --  (C) 1999 Anonymizer Inc.

   Mixmaster may be redistributed and modified under certain conditions.
   This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
   ANY KIND, either express or implied. See the file COPYRIGHT for
   details.

   Interface to cryptographic library
   $Id: crypto.h,v 1.35 1999/05/20 15:56:28 um Exp $ */


#ifndef _CRYPTO_H
#define _CRYPTO_H
#include "mix3.h"

#ifdef USE_SSLEAY
#include <crypto.h>
#if (SSLEAY_VERSION_NUMBER < 0x0800)
#error "This version of SSLeay is not supported. Please get OpenSSL from http://www.openssl.org"
#endif
#include <des.h>
#if (SSLEAY_VERSION_NUMBER <= 0x0923) && !defined(HEADER_E_OS2_H)
typedef unsigned char const_des_cblock[8];
#endif
#include <blowfish.h>
#include <md5.h>
#include <sha.h>
#if SSLEAY_VERSION_NUMBER >= 0x0900
#include <ripemd.h>
#endif
#include <bn.h>
#include <dh.h>
#include <dsa.h>
#include "dsasign.h"
#ifdef USE_RSA
#include <rsa.h>
#endif
#ifdef USE_IDEA
#include <idea.h>
#endif
#if SSLEAY_VERSION_NUMBER >= 0x0900
#include <cast.h>
#endif
#include <rand.h>

#ifdef USE_RSA
typedef RSA PUBKEY;
typedef RSA SECKEY;
#endif

#else
/* #error "No crypto library." */
typedef void PUBKEY;
typedef void SECKEY;

#endif

#endif
